class DotCurvedTail implements Shape {
  color dColor;
  boolean dIsHollow;
  boolean dSlopeIsDownward;
  boolean dNoSlope;
  float dMaxEllipseSize; //0-1
  float dFatness; //0-1
  int minXSize, minYSize, maxXSize, maxYSize;

  //Dot
  DotCurvedTail() {
    //defaults
    dIsHollow = false;
    dSlopeIsDownward = true;
    dMaxEllipseSize = 0.4;
    dFatness = 0.3;
  } //Dot

  //updateDraw
  @Override
    void updateDraw(int dOriginX, int dOriginY, int dWidth, int dHeight, PGraphics buffer) {
    dColor = getDotColor();

    //    dSlopeIsDownward = random(1) > 0.5;

    buffer.ellipseMode(LEFT);

    buffer.pushMatrix();
    buffer.translate(dOriginX, dOriginY);

    if (showRects) {
      buffer.fill(120, 80, 0);
      buffer.stroke(0);
      buffer.rect(0, 0, dWidth, dHeight);
    }

    float minEllipseSize = (dHeight * dMaxEllipseSize) / 4.0;

    //tail
    int divi = max(dWidth, dHeight);
    int requiredEllipses = int((divi / minEllipseSize) * 6);

    float targetEndY;
    targetEndY = dHeight - minEllipseSize;

    dSlopeIsDownward = random(1) > 0.5;
    dIsHollow = random(1) > 0.66;

    for (int i=0; i<requiredEllipses; i++) {
      buffer.noStroke();
      buffer.fill(dColor);

      float divisor = dHeight / minEllipseSize;
      if (dFatness <= 0) {
        divisor = dHeight / minEllipseSize;
      } 
      else {
        divisor = ((pow(float(i) / requiredEllipses, 1.0/max(0.01, 1.0 - dFatness))) * 3.0 + 1); //should be 1.0 - 4.0
      }
      float dSize = (dHeight * dMaxEllipseSize) / divisor;
      float dSizeHalf = dSize / 2.0;
      float xPosition = (float(i) / float(requiredEllipses)) * (dWidth - dSize); 

      float yPosition = pow((float(i) / float(requiredEllipses)), 2) * (targetEndY);
      //      println(requiredEllipses+" ypos");

      if (dSlopeIsDownward) {
        buffer.ellipse(xPosition, yPosition, dSize, dSize);
      } 
      else {
        buffer.ellipse(xPosition, dHeight - yPosition - dSize, dSize, dSize);
      }
    }

    //main dot
    //    buffer.noStroke();
    //    buffer.fill(dColor);
    float dSize = dHeight * dMaxEllipseSize;
    //    if (dSlopeIsDownward) {
    //      buffer.ellipse(0, 0, dSize, dSize);
    //    } 
    //    else {
    //      buffer.ellipse(0, dHeight - dSize, dSize, dSize);
    //    }

    if (dIsHollow) {
      buffer.fill(bgColor);
      float scaler = 0.55;
      if (dSlopeIsDownward) {
        buffer.ellipse(0 + (((1.0 - scaler) / 2.0) * (dHeight * dMaxEllipseSize)), 0 + (((1.0 - scaler) / 2.0) * (dHeight * dMaxEllipseSize)), dHeight * scaler * dMaxEllipseSize, dHeight * scaler * dMaxEllipseSize);
      } 
      else {
        buffer.ellipse(0 + (((1.0 - scaler) / 2.0) * (dHeight * dMaxEllipseSize)), dHeight - (((1.0 - scaler) / 2.0) * dSize) - (dSize * scaler), dSize * scaler, dSize * scaler);
      }
    } 
    buffer.popMatrix();
  } //updateDraw

  void setSizes(int minX, int minY, int maxX, int maxY) {
    minXSize = minX;
    minYSize = minY;
    maxXSize = maxX;
    maxYSize = maxY;
  }
  int minXSize() {
    return minXSize;
  }
  int minYSize() {
    return minYSize;
  }
  int maxXSize() {
    return maxXSize;
  }
  int maxYSize() {
    return maxYSize;
  }
}
